// INCLUIMOS LAS LIBRERÍAS QUE VAMOS A UTILIZAR
#include <DHT.h>

// Descomentar el Sensor que vayamos a utilizar

#define DHTPIN 2
#define DHTTYPE DHT11   // DHT 11
//#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
 
// DECLARACIÓN DE VARIABLES

DHT dht(DHTPIN, DHTTYPE);

#include <LiquidCrystal_I2C.h> // Incluimos la librería del modulo LCD con el adapatador disminuidor de pines

// Creación de objetos LCD
LiquidCrystal_I2C lcd(0x27, 16, 2); 

//Hasta aquí hemos declarado la librería para la LCD y los pines por donde le va a entrar la información.

#include <Time.h>
#include <TimeLib.h>

// Declaramos la variable del tipo time_t
time_t fecha;
 
// INICIALIZACIÓN DEL PROGRAMA (SE EJECUTA SOLO UNA VEZ)
void setup()
{
  Serial.begin(9600);            // inicializamos la comunicación Serie
  dht.begin();                	// inicializamos el objeto dht

// Iniciar pantalla
  lcd.begin();
  lcd.backlight();//Retroiluminar pantalla
  
lcd.setCursor(0,0);
lcd.print(" Temp y Humedad"); // Indicamos lo que queremos que salga en la segunda línea al principio
lcd.setCursor(0,1);
lcd.print("     Sensor     ");

// Establecemos la fecha
  setTime(19, 45, 0, 15, 12, 2019);
 
  // Obtenemos la fecha actual
  time_t t = now();
}

// LOOP CENTRAL DEL PROGRAMA (SE EJECUTA CONSTANTEMENTE DE FORMA SECUENCIAL) 
void loop() {
  delay(5000);
  // Leer la temperatura y la humedad toma al rededor de 250milisegundos
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  
 
  if (isnan(h) || isnan(t)) {

    Serial.println("Error de lectura");
  }
  else{ 
  //mostrar valores en el LCD 1602
  Serial.print("Humedad: ");
  Serial.println(h);
  Serial.print("Temp: ");
  Serial.println(t);
  }

   // Escribir los valores en el LCD
  lcd.clear(); //Borrar valores anteriores
  humedad (); // Escribir la humedad en la pantalla LCD
  temperatura (); // Escribir la temperatura y agua en la pantalla LCD
  Hora ();
// Esperar un segundo antes de repetir
  delay (1000);
}

void humedad ()
{
  lcd.setCursor(0, 0);
  lcd.print("Hum:");
  lcd.print(dht.readHumidity());
  lcd.print("%");
  
 }

void temperatura ()
{
  lcd.setCursor(0, 1);
  lcd.print("T:");
  lcd.print(dht.readTemperature());
  lcd.print(" C");
}
void Hora ()
{time_t t = now();
  lcd.setCursor(11, 0);
  lcd.print(hour(t));
  lcd.setCursor(13, 0);
  lcd.print(":");
  lcd.setCursor(14, 0);
  lcd.print(minute(t));
  lcd.setCursor(13, 1);
  lcd.print(second(t));

}
